- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# PK_MessageAccumulatorBase Class Reference

Inheritance diagram for PK_MessageAccumulatorBase:

List of all members.

## Detailed Description

Definition at line 283 of file pubkey.h.

## Public Member Functions
| PK_MessageAccumulatorBase ()
virtual HashTransformation & | AccessHash ()=0
void | Update (const byte *input, size_t length)
| process more input
unsigned int | DigestSize () const
| should not be called on PK_MessageAccumulator
void | TruncatedFinal (byte *digest, size_t digestSize)
| should not be called on PK_MessageAccumulator
HashTransformation & | Ref ()
| return a reference to this object,
virtual byte * | CreateUpdateSpace (size_t &size)
| request space to write input into
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | Restart ()
| discard the current state, and restart with a new message
virtual unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
virtual unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| truncated version of VerifyDigest()
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Public Attributes
SecByteBlock | m_recoverableMessage
SecByteBlock | m_representative
SecByteBlock | m_presignature
SecByteBlock | m_semisignature
Integer | m_k
Integer | m_s
bool | m_empty
## Protected Member Functions
void | ThrowIfInvalidTruncatedSize (size_t size) const

## Member Function Documentation

HashTransformation& HashTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary HashTransformation object to a function that takes a non-const reference.

Definition at line 527 of file cryptlib.h.

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

compute hash for current message, then restart for a new message

Precondition:
  size of digest == DigestSize().

Definition at line 537 of file cryptlib.h.

Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), DefaultEncryptor::FirstPut(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

verify that digest is a valid digest for the current message, then reinitialize the object

Default implementation is to call Final() and do a bitwise comparison between its output and digest.

Definition at line 563 of file cryptlib.h.

Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

The documentation for this class was generated from the following file:

- pubkey.h